from locals import *
from scrollable_sprite import ScrollableSprite
from game import g

class Background(ScrollableSprite):
    SUPERSCROLL_SPEED = -2500

    def __init__(self):
        ScrollableSprite.__init__(self)

        self.image, self.single_size, self.superscrolling = g.assets["background"] # This is a doubled image
        self.disp_rect = self.image.get_rect()

        self.t = g.get_ticks()

    def update_rect(self, scroll_offset, horizontal):
        if self.superscrolling:
            t = g.get_ticks() - self.t
            offset = int(self.SUPERSCROLL_SPEED * (t / 1000.))
        else:
            offset = scroll_offset

        # Get the correct rect from the "doubled" image to allow the background to repeat forever
        if horizontal:
            # horizontal
            r = self.disp_rect.move(offset, 0)

            while r.left > 0:
                r.left -= self.single_size

            while r.right < SCREEN_WIDTH:
                r.right += self.single_size
        else:
            # vertical
            r = self.disp_rect.move(0, offset)

            while r.top > 0:
                r.top -= self.single_size

            while r.bottom < SCREEN_HEIGHT:
                r.bottom += self.single_size

        self.rect = r