from locals import *
from game import g

class IntroScreenBase(object):
    INTRO_SOUND = None
    INTRO_MUSIC = None

    def __init__(self, screen):
        self.screen = screen

    def _img(self, fn):
        return pygame.image.load(fn).convert_alpha()

    def play(self):
        channels = []

        if self.INTRO_SOUND is not None:
            if isinstance(self.INTRO_SOUND, list):
                for snd in self.INTRO_SOUND:
                    channels.append(g.assets[snd]['sound'].play())
            else:
                channels.append(g.assets[self.INTRO_SOUND]['sound'].play())

        if self.INTRO_MUSIC is not None:
            channels.append(g.assets[self.INTRO_MUSIC]['sound'].play(loops=-1))

        self.screen.fill((0, 0, 0))
        self.screen.blit(g.assets[self.INTRO_IMAGE].image, (0, 0))
        pygame.display.update()

        while True:
            for event in pygame.event.get():
                if event.type == QUIT or (event.type == KEYUP and event.key == K_ESCAPE):
                    for c in channels:
                        c.stop()
                    return USER_EXIT

                elif event.type == KEYDOWN and event.key == K_SPACE:
                    for c in channels:
                        c.stop()
                    return LEVEL_BEATEN

class TitleScreen(IntroScreenBase):
    INTRO_IMAGE = "title_screen"

class IntroScreen(IntroScreenBase):
    INTRO_IMAGE = "intro_screen"
    INTRO_MUSIC = 'intro_music'
    INTRO_SOUND = 'intro_voice'

class GameOverScreen(IntroScreenBase):
    INTRO_IMAGE = 'gameover_screen'
    INTRO_SOUND = 'gameover_sound'

class EndingScreen(IntroScreenBase):
    INTRO_IMAGE = 'ending_screen'
    INTRO_SOUND = [ "end_sequence2-censored", 'car-chirp' ]
    INTRO_MUSIC = 'intermission'

class CreditsScreen(IntroScreenBase):
    INTRO_IMAGE = 'credits_screen'
    INTRO_MUSIC = 'outerspaceboss'
    INTRO_SOUND = 'boss_battle'
