from locals import *
from game import g

class ScoreBar_Background(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)

        self.image = g.assets["hud"].image
        self.rect = self.image.get_rect().move(0, 10)

class ScoreBar_LifeCounter(pygame.sprite.Sprite):
    def update(self, *args):
        self.image = g.assets["lives-font"].render(str(g.score.lives), False, (255, 228, 181)).convert_alpha()
        self.rect = self.image.get_rect().move(130+40, 22)

class ScoreBar_HealthCounter(pygame.sprite.Sprite):
    def update(self, *args):
        bar = g.assets["health-bar"].image
        bar_rect = bar.get_rect()
        n = g.score.health

        self.image = pygame.Surface((bar_rect.width * n, bar_rect.height), 0, bar)
        for i in range(n):
            self.image.blit(bar, (bar_rect.width * i, 0))

        self.rect = self.image.get_rect().move(280, 10)

class ScoreBar_Weapon(pygame.sprite.Sprite):
    def update(self, *args):
        if g.score.weapon is None:
            self.image = pygame.Surface((0, 0))
        else:
            self.image = g.assets[g.score.weapon.ICON].image

        self.rect = self.image.get_rect().move(1224, 10)

class ScoreBar_FPS(pygame.sprite.Sprite):
    def update(self, *args):
        self.image = g.assets["lives-font"].render("Fps: %d" % g.get_fps(), False, (255, 228, 181)).convert_alpha()
        self.rect = self.image.get_rect().move(500, 22)

class ScoreBar(pygame.sprite.OrderedUpdates):
    def __init__(self):
        pygame.sprite.OrderedUpdates.__init__(self)

        self.add(ScoreBar_Background())
        self.add(ScoreBar_LifeCounter())
        self.add(ScoreBar_HealthCounter())
        self.add(ScoreBar_Weapon())
        if DEBUG_MODE:
            self.add(ScoreBar_FPS())